import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Calculations
{
    public static Console console = new Console();
    public static MainApplication calculator;
    public static ArrayList<String> library = new ArrayList<String>();
    public static String invalidArgumentsAmountError = "You have entered an invalid amount of arguments. Please only use two arguments, or switch to PEMDAS";
    public static Pemdas pemdas = new Pemdas();
    
    public Calculations(){
   
    library.add("multiply");
    library.add("divide");
    library.add("subtract");
    library.add("add");
    library.add("COS");
    library.add("SIN");
    library.add("TAN");
    library.add("invertS");
    library.add("invertN");
    library.add("factorial");
    library.add("switchunit");
    library.add("clear");
    library.add("storeM");
    library.add("resetM");
    library.add("recallM");
    library.add("displayM");
    library.add("PEMDAS");
    library.add("BASIC");
    
        
    }

    public String getCommand(String userInput)
    {
        boolean foundCommand = false;
        String command = "";
        String result = "";
        
        String[] inputArr = userInput.split(" ");
        for(int i = 0; i < library.size(); i ++)
        {
            String currCommand = library.get(i);
            if(currCommand.equalsIgnoreCase(inputArr[0]))
            {
                command = currCommand;
                foundCommand = true;
                break;
            }
        }
        
        switch(command)
        {
            case "multiply":
                result = Multiply(userInput);
            break;
            
            case "divide":
                result = Divide(userInput);
            break;
            
            case "add":
                result = Add(userInput);
            break;
            
            case "subtract":
                result = Subtract(userInput);
            break;
            
            case "invertS":
                result = InvertSign(userInput);
            break;
            
            case "invertN":
                result = InvertNumber(userInput);
            break;   
            
            case "clear":
                Clear();
            break;
            
            case "PEMDAS":   
                System.out.println("You have just entered PEMDAS mode.");
                this.calculator.state = "PEMDAS";
            break;
            
            case "BASIC":
                System.out.println("You have just entered basic mode");
                this.calculator.state = "basic";
            break;
            
        }
        return result;
    }
    
    public static ArrayList<Double> getNumbers(String userInput){
        ArrayList<Double> results = new ArrayList<Double>();
        
        //takes in a string
        //finds the first occurence of a number
        //store it as a double ( left )
        //add this to the arraylist
        //find the second occurence of a number
        //store it as a double (right)
        //add this to the array list
        //if the size of the arraylist is 2
            //return the array list
        //else return null'
        
        Pattern pattern = Pattern.compile("\\s?\\-?\\.?\\d+\\.?(\\d+)?\\s?");
        Matcher matcher = pattern.matcher(userInput);
        
        while(matcher.find()){
            String number = matcher.group().trim();
            Double deci = Double.valueOf(number);

            results.add(deci);
        }
        
        if(results.size() == 2)
        { 
            return results;
        }
        return null;
    }
    
    public static ArrayList<Double> getNumber(String userInput){
        ArrayList<Double> results = new ArrayList<Double>();
        
        //takes in a string
        //finds the first occurence of a number
        //store it as a double ( left )
        //add this to the arraylist
        //find the second occurence of a number
        //store it as a double (right)
        //add this to the array list
        //if the size of the arraylist is 2
            //return the array list
        //else return null'
        
        Pattern pattern = Pattern.compile("\\s?\\-?\\.?\\d+\\.?(\\d+)?\\s?");
        Matcher matcher = pattern.matcher(userInput);
        
        while(matcher.find()){
            String number = matcher.group().trim();
            Double deci = Double.valueOf(number);
            
            results.add(deci);
            
        }
        
        if(results.size() == 1)
        { 
            System.out.println(results.get(0));
            return results;
        }
        
        return null;
    }
    
    public static String Multiply(String userInput)
    {
        String result = "";
        ArrayList<Double> results = getNumbers(userInput);
        if(results != null)
        {
            Double product = results.get(0) * results.get(1);
            result = String.valueOf(product);
            return result;
        } else {
            return invalidArgumentsAmountError;
        }
    }

    public static String Divide(String userInput)
    {
        //perform the operation
        //convert to string
        //return string
        String result = "";
        ArrayList<Double> results = getNumbers(userInput);
        if(results != null)
        {
            Double quotient = results.get(0) / results.get(1);
            result = String.valueOf(quotient);
            return result;
        } else {
            return invalidArgumentsAmountError;
        }
        
        
    } 

        public static String Add(String userInput)
    {
        String result = "";
        ArrayList<Double> results = getNumbers(userInput);
        if(results != null)
        {
            Double sum = results.get(0) + results.get(1);
            result = String.valueOf(sum);
            return result;
        } else {
            return invalidArgumentsAmountError;
        }
        
    }
    
    public static String Subtract(String userInput)
    {
        //perform the operation
        //convert to string
        //return string
        String result = "";
        ArrayList<Double> results = getNumbers(userInput);
        if(results != null)
        {
            Double difference = results.get(0) - results.get(1);
            result = String.valueOf(difference);
            return result;
        } else {
            return invalidArgumentsAmountError;
        }
        
    }
 
    public static String InvertSign(String userInput)
    {
        //perform the operation
        //convert to string
        //return string
        return null;
    }  
    
    public static String InvertNumber(String userInput)
    {
        //perform the operation
        //convert to string
        //return string
        return null;
    } 

    public static void Clear()
    {
        //reset the default value to 0
    }
}
